package org.s4s.gui.views;

import com.vaadin.navigator.ViewChangeListener;
import com.vaadin.ui.Alignment;
import com.vaadin.ui.HorizontalLayout;
import com.vaadin.ui.Notification;
import com.vaadin.ui.Panel;
import com.vaadin.ui.UI;
import com.vaadin.ui.VerticalLayout;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.s4s.dao.ProductDAO;
import org.s4s.exceptions.DAOException;
import org.s4s.modell.dto.Product;
import org.s4s.process.control.ProductSearch;
import org.s4s.services.util.Views;

/**
 *
 * @author Holger
 */
public class ArtikeldetailsView extends TemplateView {

    private Product product = new Product();
    private final ProductDAO products = ProductSearch.getInstance();
    private VerticalLayout verticalLayout = new VerticalLayout();

    @Override
    public void enter(ViewChangeListener.ViewChangeEvent event) {
        if (event.getParameters() != null) {
            // split at "/", add each part as a label
            String str = event.getParameters();
            int id = Integer.parseInt(str);

            this.setUp(id);
        } else {
            Notification.show(null, "Kein Artikel ausgewählt!", Notification.Type.HUMANIZED_MESSAGE);
            UI.getCurrent().getNavigator().navigateTo(Views.WELCOME);
        }
    }

    public void setUp(int id) {
        getInformation(id);
        super.setUpFooterAndHeader(verticalLayout);
    }

    private void getInformation(int id) {
        try {
            product = products.getProductById(id);
            HorizontalLayout horizontalLayout = new HorizontalLayout();
            Panel p = new Panel("Name: " + product.getName());
            horizontalLayout.addComponent(p);
            horizontalLayout.setComponentAlignment(p, Alignment.MIDDLE_LEFT);
            verticalLayout.addComponent(horizontalLayout);
            this.addComponent(verticalLayout);
        } catch (DAOException ex) {
            Logger.getLogger(ArtikeldetailsView.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
}
